>From 666f7ee81e53bf2e7018384363307b51fa1bad26 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Sat, 18 Feb 2017 05:34:00 +0100
Subject: [PATCH] Renamed index.html to index.jsp in CA UI.

The index.html files in CA UI have been renamed to index.jsp such
that they can be protected by access banner.

https://fedorahosted.org/pki/ticket/2582
---
 base/ca/shared/webapps/ca/{ee/index.html => admin/index.jsp}            | 0
 base/ca/shared/webapps/ca/agent/ca/{index.html => index.jsp}            | 0
 base/ca/shared/webapps/ca/agent/header.template                         | 2 +-
 base/ca/shared/webapps/ca/agent/{index.html => index.jsp}               | 0
 base/ca/shared/webapps/ca/agent/index.template                          | 2 +-
 base/ca/shared/webapps/ca/ee/ca/{index.html => index.jsp}               | 0
 .../shared/webapps/ca/ee/ca/policyEnrollment/{index.html => index.jsp}  | 0
 .../shared/webapps/ca/ee/ca/profileEnrollment/{index.html => index.jsp} | 0
 base/ca/shared/webapps/ca/{admin/index.html => ee/index.jsp}            | 0
 base/ca/shared/webapps/ca/{index.html => index.jsp}                     | 0
 10 files changed, 2 insertions(+), 2 deletions(-)
 rename base/ca/shared/webapps/ca/{ee/index.html => admin/index.jsp} (100%)
 rename base/ca/shared/webapps/ca/agent/ca/{index.html => index.jsp} (100%)
 rename base/ca/shared/webapps/ca/agent/{index.html => index.jsp} (100%)
 rename base/ca/shared/webapps/ca/ee/ca/{index.html => index.jsp} (100%)
 rename base/ca/shared/webapps/ca/ee/ca/policyEnrollment/{index.html => index.jsp} (100%)
 rename base/ca/shared/webapps/ca/ee/ca/profileEnrollment/{index.html => index.jsp} (100%)
 rename base/ca/shared/webapps/ca/{admin/index.html => ee/index.jsp} (100%)
 rename base/ca/shared/webapps/ca/{index.html => index.jsp} (100%)

diff --git a/base/ca/shared/webapps/ca/ee/index.html b/base/ca/shared/webapps/ca/admin/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/ee/index.html
rename to base/ca/shared/webapps/ca/admin/index.jsp
diff --git a/base/ca/shared/webapps/ca/agent/ca/index.html b/base/ca/shared/webapps/ca/agent/ca/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/agent/ca/index.html
rename to base/ca/shared/webapps/ca/agent/ca/index.jsp
diff --git a/base/ca/shared/webapps/ca/agent/header.template b/base/ca/shared/webapps/ca/agent/header.template
index 91bed383a8c9dc863226f6156c9adf96c210614f..5157c2f11763b577b5ad98c4b9374ea38be5a50e 100644
--- a/base/ca/shared/webapps/ca/agent/header.template
+++ b/base/ca/shared/webapps/ca/agent/header.template
@@ -83,7 +83,7 @@ $(function() {
 		} else {
           		document.write('<a href="../' + 
 				result.recordSet[i].id + 
-				'/index.html" target="_top">' + 
+				'/" target="_top">' + 
 				type + '<\/a>');
 		}
 		document.write('<\/font><\/td>');
diff --git a/base/ca/shared/webapps/ca/agent/index.html b/base/ca/shared/webapps/ca/agent/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/agent/index.html
rename to base/ca/shared/webapps/ca/agent/index.jsp
diff --git a/base/ca/shared/webapps/ca/agent/index.template b/base/ca/shared/webapps/ca/agent/index.template
index bc2eb9ff05afaa52f9a3e59a2c76b1e6a46bf6b0..1213fdb2580e32bd6b5c475a35fac120a60d99b6 100644
--- a/base/ca/shared/webapps/ca/agent/index.template
+++ b/base/ca/shared/webapps/ca/agent/index.template
@@ -110,7 +110,7 @@ if (result.header.errorDetails != null) {
           	document.write('<td>');
 		document.write('<font face="PrimaSans BT, Verdana, sans-serif">');
 		document.write('<a href="');
-		document.write(result.recordSet[i].id + '/index.html');
+		document.write(result.recordSet[i].id + '/');
 		if (result.recordSet[i].type == "RegistrationAuthority") {
 			document.write('">Registration Manager Agent Services</a></font>');
 			document.write('<font size="-1" face="PrimaSans BT, Verdana, sans-serif"><br>');
diff --git a/base/ca/shared/webapps/ca/ee/ca/index.html b/base/ca/shared/webapps/ca/ee/ca/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/ee/ca/index.html
rename to base/ca/shared/webapps/ca/ee/ca/index.jsp
diff --git a/base/ca/shared/webapps/ca/ee/ca/policyEnrollment/index.html b/base/ca/shared/webapps/ca/ee/ca/policyEnrollment/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/ee/ca/policyEnrollment/index.html
rename to base/ca/shared/webapps/ca/ee/ca/policyEnrollment/index.jsp
diff --git a/base/ca/shared/webapps/ca/ee/ca/profileEnrollment/index.html b/base/ca/shared/webapps/ca/ee/ca/profileEnrollment/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/ee/ca/profileEnrollment/index.html
rename to base/ca/shared/webapps/ca/ee/ca/profileEnrollment/index.jsp
diff --git a/base/ca/shared/webapps/ca/admin/index.html b/base/ca/shared/webapps/ca/ee/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/admin/index.html
rename to base/ca/shared/webapps/ca/ee/index.jsp
diff --git a/base/ca/shared/webapps/ca/index.html b/base/ca/shared/webapps/ca/index.jsp
similarity index 100%
rename from base/ca/shared/webapps/ca/index.html
rename to base/ca/shared/webapps/ca/index.jsp
-- 
2.5.5